// cap_sts.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "cusb2.h"
#include <tlhelp32.h>
#include <io.h>
#include <mmsystem.h>

#include "BonTsEngine/TsPacketParser.h"
#include "BonTsEngine/TsDescrambler.h"
#include "BonTsEngine/FileWriter.h"
#include "BonTsEngine/TsServiceSelect.h"
#include "Common/Buffer.h"
#include "UdpOutput.h"
#include "TsSelectDump.h"

#pragma warning( disable : 4996)
#pragma comment(lib, "winmm.lib")

//#define DEBUG_FW
//#define TS_BACK
#define S_MARGIN	(-30)		// ^Jn}[W
#define SE_MARGIN	(-30)		// ~v}[W
#define E_MARGIN	(+30)		// ^I}[W
#define APPVER		"Ver0.02(15)"

#ifdef DEBUG_FW
u8 fw_iic[1024*8];
#else
u8 fw_iic[]=
#include "fw.inc"
#endif

#define CMD_EP6IN_START		0x50	//
#define	CMD_EP6IN_STOP		0x51	//
#define	CMD_EP2OUT_START	0x52	//
#define	CMD_EP2OUT_STOP		0x53	//
#define	CMD_PORT_CFG		0x54	//addr_mask, out_pins
#define	CMD_REG_READ		0x55	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56	//addr, value
#define	CMD_PORT_READ		0x57	//(return 1byte)
#define	CMD_PORT_WRITE		0x58	//value
#define	CMD_IFCONFIG		0x59	//value
#define	CMD_MODE_IDLE		0x5a
#define CMD_EP4IN_START		0x5b	//
#define	CMD_EP4IN_STOP		0x5c	//
#define	CMD_IR_CODE			0x5d	//val_l, val_h

#define BUF_LEN	(1024*32)
#define	QUE_NUM	32

#define	PIO_START	0x20
#define	PIO_IR_OUT	0x10
#define	PIO_IR_IN	0x08
#ifdef TS_BACK
#define PIO_TS_BACK	0x04
#endif

cusb2 *usb;
cusb2_tcb *tcb1;
cusb2_tcb *tcb2;

LONG cmd_len=0,ret_len=0;
u8	cmd[64];
u8  ret[64];
CCyUSBEndPoint *inep;
CCyUSBEndPoint *outep;

#define BCAS_PRE_TIME	15
#define BCAS_POST_TIME	0

time_t start_time = 0;
time_t end_time = 0;
bool bcas = false;
FILE *wfp;
FILE *wfp2;

// d
bool pon = false;
bool poff = false;

// wT[rXL^
bool bSel = false;
int  service = 0;
char szCh[10];

// M`FbN
bool bRecvChk = false;
HANDLE hRecvChkTh = NULL;
// MɃ`l蒼̂łɈړ
u16 ir_cmd[16];
s32 ir_cmd_num = 0;
u16 ir_base = 0x00;

// B25,NULLpPbgp
bool bB25 = false;
CTsPacketParser* pTSPacketParser;
CTsDescrambler* pTsDescrambler;
CTsServiceSelect* pTsServiceSelect;
CFileWriter* pFileWriter;
CUdpOutput* pUdpOutput;
CTsSelectDump* pTsSelectDump;

// cap_sts̒~
HANDLE hStopEvent = NULL;
bool bStopEventRecv = false;
bool bStop = FALSE;
char logfilename[256];
char appname[256];
char execname[256];
char eventname[256];

// cap_sts̃R}h󂯕t
HANDLE hCmdThread = NULL;
bool bCmdThreadStop = false;
char cmdMapName[256];
char cmdReqEventName[256];
char cmdResEventName[256];
typedef struct {
	BYTE	cmd;
	int		add;
	time_t	end_time;
	char szCh[10];
} SHARED_DATA;
#define CMD_ADD_MIN		1
#define RES_ADD_MIN		101
#define CMD_GET_TIME	2
#define RES_GET_TIME	102
#define CMD_CHG_CN		3
#define RES_CHG_CN		103

// UDPo
char szHostName[256];
bool bView = false;

// FIFOobt@
//CBufferMT*	m_pStreamBuf=NULL;


// Mobt@
typedef struct tagLBuffer {
#define LBUFF_LEN	(32*1024)	
	BYTE*	m_pLBuff[LBUFF_LEN];
	int		m_nLBuffLen[LBUFF_LEN];
	int		m_nLRead;
	int		m_nLWrite;
	int		m_nLCount;
	int		m_nMaxCount;
	CRITICAL_SECTION cs;

	tagLBuffer() {
		memset(this,0,sizeof(LBUFFER_DATA));
		InitializeCriticalSection(&cs);
	}
	~tagLBuffer() {
		LBufferClear();
		DeleteCriticalSection(&cs);
	}
	void LBufferClear(void) {
		EnterCriticalSection(&cs);
		LBufferClearMain();
		LeaveCriticalSection(&cs);
	}
	void LBufferClearMain(void) {
		while(m_nLCount > 0) {
			delete [] m_pLBuff[m_nLRead];
			m_nLRead++;
			if(m_nLRead == LBUFF_LEN)
				m_nLRead = 0;
			m_nLCount--;
		}
	}
	BOOL Put(BYTE** pData,int len) {
		BOOL bRc = TRUE;
		EnterCriticalSection(&cs);
		if(m_nLCount == LBUFF_LEN) {
			LBufferClearMain();
			bRc = FALSE;
		}
		m_pLBuff[m_nLWrite] = *pData;
		m_nLBuffLen[m_nLWrite] = len;
		m_nLWrite++;
		if(m_nLWrite == LBUFF_LEN)
			m_nLWrite = 0;
		m_nLCount++;
		if(m_nMaxCount < m_nLCount)
			m_nMaxCount = m_nLCount;
		LeaveCriticalSection(&cs);
		return bRc;
	}
	void Lock(void) {
		EnterCriticalSection(&cs);
	}
	void Unlock(void) {
		LeaveCriticalSection(&cs);
	}
	void MaxCount(void) {
		EnterCriticalSection(&cs);
		if(m_nMaxCount < m_nLCount)
			m_nMaxCount = m_nLCount;
		LeaveCriticalSection(&cs);
	}
	BYTE* Get(int* pLen) {
		EnterCriticalSection(&cs);
		BYTE* pData = NULL;
		if(m_nLCount > 0) {
			pData = m_pLBuff[m_nLRead];
			*pLen = m_nLBuffLen[m_nLRead];
			m_nLCount--;
			m_nLRead++;
			if(m_nLRead == LBUFF_LEN)
				m_nLRead = 0;
		}
		else
			*pLen = 0;
		LeaveCriticalSection(&cs);
		return pData;
	}
} LBUFFER_DATA;

LBUFFER_DATA m_LBuffer;

void log_out(const char* szFormat, ...)
{
	va_list Args;
	TCHAR szTempStr[4096];

	va_start(Args , szFormat);
	vsprintf(szTempStr, szFormat, Args);
	va_end(Args);

	printf(szTempStr);
	
	FILE *fout;
	if(!fopen_s(&fout, logfilename, "a+t")){
		time_t now = time(NULL);
		fwrite(szTempStr,strlen(szTempStr),1,fout);
		fclose(fout);
	}
}

bool write_func(u8 **buf, u32 len){
	time_t now;

	time( &now );							//bPʂŎ擾

	// IvIB
	if(WaitForSingleObject(hStopEvent,0) == WAIT_OBJECT_0) {
		ResetEvent(hStopEvent);
		// M̏ꍇ͎oCxgł\̂Ŗ
		if(bRecvChk) {
			log_out("Iv󂯂̂ŏI܂B\n");
			bStopEventRecv = true;
			end_time = now;			// bsco͂~邽
		}
	}
	bRecvChk = true;

	if(now < start_time && !bStopEventRecv) return true;		//BCASɋL^

	if(!m_LBuffer.Put(buf,len))
		log_out("Mobt@s\n");
	*buf = new UCHAR[BUF_LEN];
	//DWORD dwPutSize=m_pStreamBuf->Put(buf,len);
	//if(dwPutSize!=len)
	//{
	//	// Mobt@s
	//	m_pStreamBuf->Clear();
	//	printf("Mobt@s\n");
	//}
	// fR[_Otɓ
	//if(!pTSPacketParser->InputMedia(new CMediaData(buf, len))){
	//	log_out("fR[hɃG[܂B\n");
	//}

	if(now < end_time && !bStopEventRecv) return true;			//IԁH

	cmd[cmd_len++]=CMD_EP6IN_STOP;
	if(bcas == false) 
		cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}

bool write_bcas(u8 **buf, u32 len){
	time_t now;

	time( &now );			//bPʂŎ擾

	fwrite(*buf,1,len,wfp2);

	if(now < end_time + BCAS_POST_TIME) return true;

	cmd[cmd_len++]=CMD_EP4IN_STOP;
	cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}

void ir_cmdtx(u16 *ircmd, s32 n){
	s32 i;
	s32 ir_wait = 600;
	for(i=0; i<n; i++){
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=(u8)ircmd[i];
		cmd[cmd_len++]=(u8)(ircmd[i] >> 8);
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		if(ircmd[i] == (0x04d8 + ir_base)) 
			ir_wait = 300;	//3digit
		Sleep(ir_wait);
		//IRo͒~
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=0;
		cmd[cmd_len++]=0;
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		Sleep(100);
	}
}

// dON
void ponsend(void) {
	u16 cmd[16];
	s32 cmd_num = 0;
	cmd[cmd_num++] = 0x048b + ir_base;								//dON
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	ir_cmdtx(cmd, cmd_num);
}

// Jn2bĂf[^MȂꍇ͓dONƃ`ls
void recvchkthread_proc(void *para) {
	Sleep(2000);
	if(bRecvChk)
		return;
	log_out("f[^MȂ̂œdONs܂B\n");
	ponsend();
	//`lݒ
	if(ir_cmd_num != 0)
		ir_cmdtx(ir_cmd, ir_cmd_num);
	Sleep(2500);

	if(bB25)
		pTsDescrambler->Reset();
}

void CheckCh()
{
	_mbslwr((unsigned char *)szCh);
	//`l
	int n = 2;
	log_out("`l[");
	if(szCh[1] == 'b'){
		//BS
		log_out("BS");
		ir_cmd[ir_cmd_num++] = 0x04e2 + ir_base;					//BS
		if((szCh[3]==0)||(szCh[4]==0)){
			if(szCh[3] != 0){//10,11,12ch
				n = 4;
				log_out("%s", szCh+2);
				if(szCh[3] == '0')
					ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
				else
					ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (szCh[3] - '1');	//11,12ch
			}
			else{
				n = 2;
			}
		}
		else{
			ir_cmd[ir_cmd_num++] = 0x04d8 + ir_base;					//3-digit
			service = atoi(&szCh[2]);
		}
	}
	else if(szCh[1] == 'c'){
		//CS
		log_out("CS");
		ir_cmd[ir_cmd_num++] = 0x04e3 + ir_base;					//CS
		if((szCh[3]==0)||(szCh[4]==0)){
			if(szCh[3] != 0){//10,11,12ch
				n = 4;
				log_out("%s", szCh+2);
				if(szCh[3] == '0')
					ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
				else
					ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (szCh[3] - '1');	//11,12ch
			}
			else{
				n = 2;
			}
		}
		else{
			ir_cmd[ir_cmd_num++] = 0x04d8 + ir_base;					//3-digit
			service = atoi(&szCh[2]);
		}
	}
	else{
		//nfW
		log_out("nfW");
		ir_cmd[ir_cmd_num++] = 0x04d6 + ir_base;					//n
		ir_cmd[ir_cmd_num++] = 0;
		if(szCh[2] != 0){//10,11,12ch
			n = 3;
			log_out("%s", szCh+1);
			if(szCh[2] == '0')
				ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
			else
				ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (szCh[2] - '1');	//11,12ch
		}
		else{
			n = 1;
		}
	}
	while(szCh[n] != 0){
		log_out("%c",szCh[n]);
		ir_cmd[ir_cmd_num++] = 0x0480 + ir_base + (szCh[n] - '0');	//num
		n++;
	}
	log_out("]\n");
}

void cmdThread_proc(void *para)
{
	HANDLE hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
	int count = 0;
	while(!bCmdThreadStop) {
		if(WaitForSingleObject(hCmdReqEvent,0) == WAIT_OBJECT_0) {
			ResetEvent(hCmdReqEvent);
			HANDLE hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);

			HANDLE hMap; /* t@C}bsOIuWFNg̃nh */
			SHARED_DATA	 *pData; /* Lf[^ */

			/* t@C}bsOIuWFNg̍쐬 */
			hMap = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE,cmdMapName);

			if(hMap != NULL) {
				/* r[̍쐬 */
				pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
				if(pData->cmd == CMD_ADD_MIN) {
					pData->cmd = RES_ADD_MIN;
					end_time += (pData->add * 60);
					pData->end_time = end_time;
					struct tm* stm = localtime(&end_time);
					log_out("%d  %02d:%02d:%02d ܂ŋL^܂B\n",pData->add,stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				else if(pData->cmd == CMD_GET_TIME) {
					pData->cmd = RES_GET_TIME;
					pData->end_time = end_time;
				}
				else if(pData->cmd == CMD_CHG_CN && bView) {
					pUdpOutput->CloseUdpPort();
					log_out("`lؑ֗v󂯂܂B");
					//m_pStreamBuf->Clear();
					ir_cmd_num = 0;
					service = 0;
					strcpy(szCh,pData->szCh);
					CheckCh();
					struct tm* stm = localtime(&pData->end_time);
					log_out("L^Ԃ%d܂B",(pData->end_time-end_time)/60);
					log_out("%02d:%02d:%02d ܂ŋL^܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);
					end_time = pData->end_time;
					pData->cmd = RES_CHG_CN;
					//`lݒ
					if(ir_cmd_num != 0)
						ir_cmdtx(ir_cmd, ir_cmd_num);
					Sleep(2500);
					m_LBuffer.LBufferClear();
					//m_pStreamBuf->Clear();
					pTsServiceSelect->SetServiceId(service);
					pTSPacketParser->Reset();
					pTsServiceSelect->Reset();
					if(bB25)
						pTsDescrambler->Reset();
					pUdpOutput->OpenUdpPort(szHostName);
				}
				UnmapViewOfFile(pData);
				CloseHandle(hMap);
			}
			SetEvent(hCmdResEvent);
			CloseHandle(hCmdResEvent);
		}
		int len;
		BYTE* pData;
		//m_LBuffer.Lock();
		while((pData = m_LBuffer.Get(&len)) != NULL && !bCmdThreadStop) {
				// fR[_Otɓ
				//if(!pTSPacketParser->InputMedia(new CMediaData(pData, len)))
				//	log_out("fR[hɃG[܂B\n");
				//delete [] pData;
			if(!pTSPacketParser->InputMedia(new CMediaData(pData,len,TRUE)))
				log_out("fR[hɃG[܂B\n");
			count++;
			if(count > 1000) {
				Sleep(1);
				count = 0;
			}
		}
		Sleep(1);
		//m_LBuffer.Unlock();
		//Sleep(1);
		//while(m_pStreamBuf->GetDataSize()>=BUF_LEN)
		//{
		//	len=m_pStreamBuf->Get(buf,BUF_LEN);
		//	if(len>0)
		//	{
		//		// fR[_Otɓ
		//		if(!pTSPacketParser->InputMedia(new CMediaData(buf, len))){
		//			log_out("fR[hɃG[܂B\n");
		//		}
		//	}
		//}
	}
	CloseHandle(hCmdReqEvent);
}

// VOinh
BOOL WINAPI SignalHandler(DWORD dwCtrlType)
{
	BOOL bEndCheck = TRUE;
	log_out("\n");
	switch(dwCtrlType) {
		case CTRL_C_EVENT:
			log_out("CTRL+C܂\n");
			break;
		case CTRL_BREAK_EVENT:
			log_out("CTRL+BREAK܂\n");
			break;
		case CTRL_CLOSE_EVENT:
			log_out("R\[܂\n");
			break;
		case CTRL_LOGOFF_EVENT:
			log_out("OIt܂\n");
			bEndCheck = FALSE;
			break;
		case CTRL_SHUTDOWN_EVENT:
			log_out("Vbg_E܂\n");
			bEndCheck = FALSE;
			break;
	}
	if(bEndCheck) {
		char key[1024];
		printf("I܂?(Y/N)");
		scanf("%s",key);
		if(strcmpi(key,"y") == 0) {
			end_time = time(NULL);
		}
	}
	else
		end_time = time(NULL);
	return TRUE;
}

static const char *def_tsfname = "test.ts2";
static const char *def_bcasfname = "test.bcs";

int _tmain(int argc, _TCHAR* argv[])
{
	s32 i;
	s32 sleep=0;
	time_t now;
	char *tsfname = NULL, tsfname_buf[256];
	char *bcasfname = NULL, bcasfname_buf[256];
	u8 fx2id = 0;
	u16 ir_post_cmd[16];
	s32 ir_post_cmd_num = 0;
	bool pon = false;
	bool poff = false;
	int svcNo = 0;
	int dropCount = 0;
	char retryCmdLine[1024];

	retryCmdLine[0] = 0x00;

#ifdef DEBUG_FW
	FILE *fp;
	fopen_s(&fp, "fw\\fifo.iic","rb");
	//fopen_s(&fp, "fw\\fifo_sdcc.iic","rb");
	fread(fw_iic, 1, sizeof(fw_iic), fp);
#endif
	u32 cap_mb = 10;

	// Op̃t@C쐬
	char szModulePath[256],drv[10],path[256],ext[256];
	GetModuleFileName(NULL,szModulePath,256);
	_splitpath(szModulePath,drv,path,appname,ext);
	_makepath(logfilename,drv,path,appname,".log");
	_makepath(execname,NULL,NULL,appname,ext);
	sprintf(eventname,"%s_stopeventname",appname);
	sprintf(cmdMapName,"%s_cmdMapFileName",appname);
	sprintf(cmdReqEventName,"%s_cmdReqEventName",appname);
	sprintf(cmdResEventName,"%s_cmdResEventName",appname);

	// p[^sɂ邽߈ꎞޔ
	memset(szCh,0,10);

	time( &now );			//bPʂŎ擾
	if(argc == 1){
		printf("g %s\n",APPVER);
		printf("%s [t@C] [@`l] [] [B] [Il]\n",appname);
		printf("  t@CFgqȗ\".ts2\"Bt@Cȗ\"test.ts2\"B\n");
		printf("              t@C݂ꍇ\"(l)\"t܂B\n");
		printf("              \"*\"w莞\"%s_N_b_@`l\"ƂȂ܂B\n",appname);
		printf("  P         FJnɓdONsB\n");
		printf("  POFF      FIɓdOFFs\n");
		printf("  Rl(1-3)F`[i[̃RԍwB\n");
		printf("  `lFnfW\"@1\"`\"@12\"BBS\"@B3\"ACS\"@C2\"A3wB\n");
		printf("        Fl\"30\"ŋL^()B\"19:00-19:30\"ŎwB\n");
		printf("  B         FBCASO𓯎ɋL^Bgq\".bcs\"B\n");
		printf("  Il     FΏۂ̃JIFX2IDwBȗ0B\n");
		printf("  B25       FJ[h[_gB25s܂B\n");
		printf("              (]ʂ╉ׂɂĂ̓hbv̂ŒӂĂB)\n");
		printf("  SEL       FnfWł̓f[^̍폜s܂B\n");
		printf("              BS/CSCH3wsꍇ͎w`l̃T[rX݂̂\n");
		printf("              L^܂B\n");
		printf("  SVCxxxx   FSELŋL^T[rXԍw肵܂B (BS/CSCH3w肵\n");
		printf("              ꍇCHlLƂȂ܂B)\n");
		printf("  DROPxxxx  F1bԂɎwDropꍇ%s̍ċNs܂\n",appname);
		printf("  UDP h:p   FUDPo͂sB(ts/bcst@Co͍͂s܂\n");
		printf("  STOP      Fݓ쒆%sɏIvo܂(^擙͍s܂)\n",appname);
		printf("  ADD     Fݓ쒆%s̏IԂw蕪܂(^擙͍s\n",appname);
		printf("              )\n");
		printf("\ngp၄\n");
		printf("ucap_sts j[X @B101 30v BS101\"j[X.ts2\"ō쐬BL^Ԃ30B\n");
		printf("ucap_sts 19:00-19:30 Bv `l19:00-19:30\"test.ts2\"\"test.bcs\"B\n");
		exit(-1);
	}
	else{
		// ^XNspɃOɎc
		struct tm *ntm = localtime(&now);
		log_out("%04d/%02d/%02d %02d:%02d:%02d %sJn %s\n",ntm->tm_year+1900,ntm->tm_mon+1,ntm->tm_mday,ntm->tm_hour,ntm->tm_min,ntm->tm_sec,appname,APPVER);
		for(i=0; i<argc; i++)
			log_out("%s ",argv[i]);
		log_out("\n");
		strcat(retryCmdLine,"\"");
		strcat(retryCmdLine,argv[0]);
		strcat(retryCmdLine,"\"");
		for(i=1; i<argc; i++){
			BOOL bTime = FALSE;
//			_mbslwr((unsigned char *)argv[i]);		t@C܂ŏ̂ō폜
			if(('0' <= argv[i][0]) && (argv[i][0] <= '9')){
				bTime = TRUE;
				for(int cnt = 0;cnt < (int)strlen(argv[i]);cnt++) {
					if(('0' <= argv[i][cnt]) && (argv[i][cnt] <= '9'));
					else if(':' == argv[i][cnt] || '-' == argv[i][cnt]);
					else {
						bTime = FALSE;
						break;
					}
				}
			}
			if(bTime) {
				//
				if(strchr(argv[i], ':')!=NULL){//nn:nnw
					struct tm *nt;
					s32 st_h,st_m,en_h,en_m;
					nt = localtime( &now );	// tm \̌`ɕϊ
					if(sscanf(argv[i], "%d:%d-%d:%d", &st_h, &st_m, &en_h, &en_m) == 4){//폈
						if((st_h * 60 + st_m) < (nt->tm_hour * 60 + nt->tm_min)){
							//Ȃ̂24Ԓǉ
							st_h += 24;
							en_h += 24;
						}
						if((st_h * 60 + st_m) > (en_h * 60+ en_m))
							//It܂̂
							en_h += 24;
						//bH
						sleep = (st_h * 60*60 + st_m * 60) - (nt->tm_hour * 60*60 + nt->tm_min * 60 + nt->tm_sec);
						end_time = now + sleep + ((en_h * 60*60 + en_m * 60) - (st_h * 60*60 + st_m * 60));
						int min = (en_h * 60 + en_m) - (st_h * 60 + st_m);
						st_m = sleep - (sleep/(60*60))*(60*60);
						log_out("%2.2d:%2.2d:%2.2d bォ%2.2d:%2.2d ԋL^܂B\n", sleep/(60*60), st_m/60 , sleep%60, min/60, min%60);
					}
				}
				else{
					char *s;
					int min = strtol(argv[i], &s, 10);
					end_time = now + min*60;
					log_out("ݎ%2.2d:%2.2d ԋL^܂B\n", min/60, min%60);
				}
			}
			else if(argv[i][0] == '@'){
				// `lw
				strcpy(szCh,argv[i]);
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "b") == 0){
				//BCASOw
				bcas = true;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "b25") == 0){
				//B25w
				bB25 = true;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if((argv[i][0] == 'r' || argv[i][0] == 'R') && isdigit(argv[i][1]) && (argv[i][2]==0) ){
				char *s;
				ir_base = (u8)strtol(argv[i]+1, &s, 10);
				printf("Rԍ %d ɐݒ肵܂B\n", ir_base);
				ir_base = (ir_base - 1) * 0x80;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "p") == 0) {
				pon = true;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "poff") == 0) {
				poff = true;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "stop") == 0){
				//Ivw
				bStop = true;
			}
			else if(strcmpi(argv[i], "sel") == 0){
				//T[rXI
				bSel = true;
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strnicmp(argv[i], "svc", 3) == 0 && isdigit(argv[i][3])) {
				//T[rXԍw
				char *s;
				svcNo = (int)strtol(argv[i]+3, &s, 10);
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strnicmp(argv[i], "drop", 4) == 0 && isdigit(argv[i][4])) {
				//hbvċNw
				char *s;
				dropCount = (int)strtol(argv[i]+4, &s, 10);
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else if(strcmpi(argv[i], "udp") == 0){
				//UDPo
				bView = true;
				if(i+1 < argc) {
					if(argv[i+1][0] >= '0' && argv[i+1][0] <= '9') {
						strcpy(szHostName,argv[i+1]);
						i++;
					}
					else
						strcpy(szHostName,"127.0.0.1:1234");
				}
				else
					strcpy(szHostName,"127.0.0.1:1234");
			}
			else if(strcmpi(argv[i], "add") == 0){
				//R}hM
				HANDLE hMap = CreateFileMapping(
					(HANDLE)0xffffffff,
					NULL,
					PAGE_READWRITE,
					0, sizeof(SHARED_DATA), 
					cmdMapName);

				SHARED_DATA* pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));

				if(i+1 < argc) {
					pData->cmd = CMD_ADD_MIN;
					pData->add = atoi(argv[i+1]);
				}
				else {
					pData->cmd = CMD_GET_TIME;
				}

				UnmapViewOfFile(pData);
				
				HANDLE hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
				HANDLE hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);
				SetEvent(hCmdReqEvent);
				CloseHandle(hCmdReqEvent);
				WaitForSingleObject(hCmdResEvent,1000);
				ResetEvent(hCmdResEvent);
				CloseHandle(hCmdResEvent);
				pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
				if(pData->cmd == RES_ADD_MIN) {
					struct tm* stm = localtime(&pData->end_time);
					printf("%d  %02d:%02d:%02d ܂ŋL^܂B\n",pData->add,stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				else if(pData->cmd == RES_GET_TIME) {
					struct tm* stm = localtime(&pData->end_time);
					printf("%02d:%02d:%02d ܂ŋL^܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				UnmapViewOfFile(pData);
				CloseHandle(hMap);
				return 0;
			}
			else if( (argv[i][0] == 'i' || argv[i][0] == 'I') && isdigit(argv[i][1]) && (argv[i][2]==0) ){
				//JFX2@IDw
				char *s;
				fx2id = (u8)strtol(argv[i]+1, &s, 10);
				log_out("^[Qbg̃JIUSB FX2ID %d ɐݒ肵܂B\n", fx2id);
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,argv[i]);
			}
			else{
				//t@C
				char *s;
				tsfname = tsfname_buf;
				bcasfname = bcasfname_buf;
				strcpy(tsfname, argv[i]);
				if(strchr(tsfname, '.') == NULL){
					strcat(tsfname, ".ts2");
				}
				strcpy(bcasfname, argv[i]);
				if((s = strchr(bcasfname, '.')) != NULL)
					*s = 0;
				strcat(bcasfname, ".bcs");
				strcat(retryCmdLine," ");
				strcat(retryCmdLine,"\"");
				strcat(retryCmdLine,argv[i]);
				strcat(retryCmdLine,"\"");
			}
		}
	}

	if(bView)
		dropCount = 0;

	/**
	if(pon) {
		//JnPONw
		ir_cmd[ir_cmd_num++] = 0x048b + ir_base;								//dON
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
	}***/

	if(poff)
		ir_post_cmd[ir_post_cmd_num++] = 0x048c + ir_base;					//dOFF

	if(szCh[0] != 0x00) {
		CheckCh();
	}

	if(service != 0)
		svcNo = service;

	//// T[rXNo0(ݒ)̏ꍇSELtONAB
	//if(service == 0)
	//	bSel = false;

	start_time = now + sleep;
	// 30bO^Jn悤ɕύX
	if(sleep != 0){
		sleep = sleep+S_MARGIN;
		if(sleep < 0) sleep = 0;
	}
	// 2cap_stsɘ^JnƂȂ̂idŃ^C~O炷
	sleep += fx2id;
	if(bcas){
		//BCASL^
		if(sleep != 0){
			sleep -= BCAS_PRE_TIME;
			if(sleep < 0) sleep = 0;
		}
		else{
			start_time += BCAS_PRE_TIME;
		}
	}
	if(end_time == 0 && !bStop) {
		if(bView)
			end_time = start_time + 24*60*60;	//UDPo͎̓ftHgL^Ԃ24
		else
			end_time = start_time + 20;	//ftHgL^Ԃ20b
		log_out("%d bォ%d bԋL^܂B\n", (int)(start_time - now), (int)(end_time - start_time));
	}
	else {
		// 30b]vɘ^悵܂B
		end_time = end_time+E_MARGIN;
	}

	// ^XNXgQƂAȊOcap_stsȂׂ
	time_t echktime = time(NULL);
	BOOL bFast = TRUE;
	BOOL bEventSend = TRUE;
	DWORD hMyProcessId = GetCurrentProcessId();
	int mode = 0;
	while(1) {
		HANDLE	hProcessSnap = NULL;
		PROCESSENTRY32   pe32;
		BOOL    bRet = FALSE;
		ZeroMemory ( &pe32, sizeof (pe32) );

		hProcessSnap = CreateToolhelp32Snapshot ( TH32CS_SNAPPROCESS, 0);
		if ( INVALID_HANDLE_VALUE == hProcessSnap ) {
			break;
		}
	
		// Jn\莞SE_MARGINbOɂȂĂ~Ȃꍇ͑Ocap_sta~
		if((start_time+SE_MARGIN+fx2id) <= time(NULL) || bStop)
			mode++;

		BOOL bExec = FALSE;
		pe32.dwSize = sizeof ( PROCESSENTRY32 );
		bRet = Process32First ( hProcessSnap, &pe32 );
		if ( bRet ) {
			do {
				// cap_sts.exe𔭌
				if(strcmpi(pe32.szExeFile,execname) == 0) {
					// ł͖
					if(pe32.th32ProcessID != hMyProcessId) {
						if(bView) {
							printf("ʂ%s쒆łBVIEW𒆒f܂B\n",appname);
							//R}hM
							HANDLE hMap = CreateFileMapping(
								(HANDLE)0xffffffff,
								NULL,
								PAGE_READWRITE,
								0, sizeof(SHARED_DATA), 
								cmdMapName);

							SHARED_DATA* pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));

							pData->cmd = CMD_CHG_CN;
							strcpy(pData->szCh,szCh);
							pData->end_time = end_time;

							UnmapViewOfFile(pData);
							
							HANDLE hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
							HANDLE hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);
							SetEvent(hCmdReqEvent);
							CloseHandle(hCmdReqEvent);
							WaitForSingleObject(hCmdResEvent,1000);
							ResetEvent(hCmdResEvent);
							CloseHandle(hCmdResEvent);
							//pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
							//if(pData->cmd == RES_CHG_CN) {
							//	printf("RES_CHG_CNM %d %d\n",end_time,pData->end_time);
							//	if(end_time > pData->end_time) {
							//		hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
							//		hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);
							//		pData->cmd = CMD_ADD_MIN;
							//		pData->add = (end_time - pData->end_time)/60;
							//		UnmapViewOfFile(pData);
							//		SetEvent(hCmdReqEvent);
							//		CloseHandle(hCmdReqEvent);
							//		printf("CMD_ADD_MINM\n");
							//		WaitForSingleObject(hCmdResEvent,1000);
							//		ResetEvent(hCmdResEvent);
							//		CloseHandle(hCmdResEvent);
							//		pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
							//	}
							//}
							//UnmapViewOfFile(pData);
							CloseHandle(hMap);
							return 0;
						}
						bExec = TRUE;
						if(mode == 1 && bEventSend) {
							// 悸EventgďIv NłSetEvent͈̂
							hStopEvent = OpenEvent(EVENT_MODIFY_STATE,FALSE,eventname);
							SetEvent(hStopEvent);
							log_out("s̕%s֏Iv𑗐M܂B\n",appname);
							CloseHandle(hStopEvent);
							bEventSend = FALSE;
						}
						else if(mode == 3) {
							// łIȂꍇ͋I
							HANDLE process_handle;
							process_handle = OpenProcess(PROCESS_TERMINATE, FALSE, pe32.th32ProcessID);
							if( process_handle ) {
								TerminateProcess(process_handle, 0);
								log_out("s̕%s~܂B\n",appname);
								CloseHandle(process_handle);
							}
						}
					}
				}
			} while ( Process32Next ( hProcessSnap, &pe32 ) );
		}
		CloseHandle ( hProcessSnap );

		if(!bExec || mode > 4)
			break;

		if(bFast && !bStop && bEventSend) {
			log_out("ʂ%s쒆łBÎ҂܂B\n",appname);
			bFast = FALSE;
		}
		Sleep(1000);
	}

	// p[^"stop"w肳Ăꍇ͂ŏI
	if(bStop)
		return 0;

	// cap_stsI҂sleep}CiXB
	time_t echktime2 = time(NULL);
	sleep -= (int)(echktime2-echktime);
	if(sleep < 0)
		sleep = 0;
	// cap_sts̏Iv󂯂邽߂̃Cxg쐬
	hStopEvent = CreateEvent(NULL,FALSE,FALSE,eventname);

	//if(end_time - start_time > 60*3){
	//	printf("Jpo[Ŵ߁AL^Ԃ3ɐ܂B\n");
	//	end_time = start_time + 60*3;
	//}

	usb = new cusb2(NULL);

	// B25p
	pTSPacketParser = new CTsPacketParser();
	pTsDescrambler = new CTsDescrambler();
	pTsServiceSelect = new CTsServiceSelect();
	pFileWriter = new CFileWriter();
	pUdpOutput = new CUdpOutput();
	pTsSelectDump = new CTsSelectDump();
	//m_pStreamBuf = new CBufferMT(15*1024*1024);
	//m_pStreamBuf->Clear();
	m_LBuffer.LBufferClear();

	pTsServiceSelect->SetServiceId(service);
	pTsServiceSelect->SetSvcNo(svcNo);
	pTsSelectDump->SetDropRetry(dropCount,retryCmdLine,end_time);

	if(bView) {
		if(!pUdpOutput->OpenUdpPort(szHostName)) {
			log_out("UDPAhXIPAhXŎw肵ĂB\n");
			return 0;
		}
	}
	// B25gpꍇ pTSPacketParser -> pTsDescrambler -> pFileWriter ƂȂ
	if(bB25) {
		// B-CASJ[hI[v
		if(!pTsDescrambler->OpenBcasCard()){
			log_out("B-CASJ[h̃I[vɎs܂B\n");
			bB25 = FALSE;
		}
		else {
			if(bSel) {
				pTSPacketParser->SetOutputDecoder(pTsServiceSelect);
				pTsServiceSelect->SetOutputDecoder(pTsDescrambler);
				if(bView)
					pTsDescrambler->SetOutputDecoder(pUdpOutput);
				else {
					pTsDescrambler->SetOutputDecoder(pTsSelectDump);
					pTsSelectDump->SetOutputDecoder(pFileWriter);
				}
			}
			else {
				pTSPacketParser->SetOutputDecoder(pTsDescrambler);
				if(bView)
					pTsDescrambler->SetOutputDecoder(pUdpOutput);
				else {
					pTsDescrambler->SetOutputDecoder(pTsSelectDump);
					pTsSelectDump->SetOutputDecoder(pFileWriter);
				}
			}
		}
	}
	// B25gpȂꍇB-CASJ[hI[vɎsꍇ pTSPacketParser -> pFileWriter ƂȂB
	if(!bB25) {
		if(bSel) {
			pTSPacketParser->SetOutputDecoder(pTsServiceSelect);
			if(bView)
				pTsServiceSelect->SetOutputDecoder(pUdpOutput);
			else {
				pTsServiceSelect->SetOutputDecoder(pTsSelectDump);
				pTsSelectDump->SetOutputDecoder(pFileWriter);
			}
		}
		else {
			if(bView)
				pTSPacketParser->SetOutputDecoder(pUdpOutput);
			else {
				pTSPacketParser->SetOutputDecoder(pTsSelectDump);
				pTsSelectDump->SetOutputDecoder(pFileWriter);
			}
		}
	}

	// VOinhǉ
	::SetConsoleCtrlHandler(SignalHandler, TRUE);

	Sleep(1000*fx2id);
	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_FIFO"/*NULL*/))
	{
		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);

		pTsServiceSelect->SetUsb(usb,outep,ir_cmd,ir_cmd_num,ir_base);

		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		//cmd[cmd_len++]=CMD_IR_CODE;
		//cmd[cmd_len++]=0x00;								//no addr(addr_mask)
		//cmd[cmd_len++]=0x00;								//no addr(addr_mask)
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;					//no addr(addr_mask)
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//out_pins  
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START,IR_OUT(out_pins)
#endif
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;			//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h
		//cmd[cmd_len++]=0xA3;			//slave FIFO, IFCLK=30MHz, IFCLKo,  (Sync)[h
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

		if(!bView) {
			if(tsfname == NULL) tsfname = (char *)def_tsfname;
			// o̓t@Cݒ
			bool bFileChange = false;
			char drv[256],path[256],name[256],name2[256],ext[256],srcName[256],srcNameB[256],szEx[10];
			_splitpath(tsfname,drv,path,name,ext);
			for(int i = 0;i < 100;i++) {
				strcpy(name2,name);
				if(i == 0)
					szEx[0] = 0x00;
				else
					sprintf(szEx,"(%d)",i);
				strcat(name2,szEx);
				_makepath(srcName,drv,path,name2,ext);
				if(_access(srcName,0) != 0) {
					tsfname = srcName;
					_makepath(srcNameB,drv,path,name2,".bcs");
					bcasfname = srcNameB;
					if(i != 0)
						bFileChange = TRUE;
					break;
				}
			}

			// t@Co͉\`FbN
			bool bFileError = false;
			FILE *fchk;
			if(fopen_s(&fchk,tsfname,"wb")) {
				bFileError = true;
			}
			else {
				size_t dmysize = fwrite("dummy",1,5,fchk);
				if(dmysize != 5)
					bFileError = true;
				fclose(fchk);
			}

			if(bFileError) {
				struct tm *stm = localtime(&start_time);
				sprintf(name,"%s_%04d%02d%02d_%02d%02d%02d%s%s",appname,stm->tm_year+1900,stm->tm_mon+1,stm->tm_mday,stm->tm_hour,stm->tm_min,stm->tm_sec,szCh[0] == 0x00 ? "":"_",szCh);
				_makepath(srcName,drv,path,name,ext);
				tsfname = srcName;
				_makepath(srcNameB,drv,path,name,".bcs");
				bcasfname = srcNameB;
				bFileChange = true;
			}

			if(bFileChange)
				log_out("o̓t@C%sɕύX܂B\n",tsfname);

			pFileWriter->OpenFile(tsfname);

			if(bcas){
				if(bcasfname == NULL) bcasfname = (char *)def_bcasfname;
				if(fopen_s(&wfp2, bcasfname, "wb")){
					log_out("File(%s) open err.\n",bcasfname);
				}
			}
		}

		int sleepleft = 0;

		if(pon)
			sleepleft += 4;
		if(ir_cmd_num != 0)
			sleepleft += 10;

		if(sleep > sleepleft){
			sleep -= sleepleft;
			log_out("[L^JnԂ܂őҋ@܂]\n");
			Sleep(sleep * 1000);
		}
		timeBeginPeriod(1);
		// d
		if(pon)
			ponsend();
		//`lݒ
		if(ir_cmd_num != 0){
			ir_cmdtx(ir_cmd, ir_cmd_num);
			Sleep(2500);
			ir_cmdtx(ir_cmd, ir_cmd_num);
			Sleep(2500);
		}

		time_t stime = time(NULL);
		struct tm* stm = localtime(&stime);
		log_out("%02d:%02d:%02d L^Jn܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);

		// bcast@C쐬bcsL^X^[g15btsL^n܂悤ɂB
		if(bcas && !bView) {
			start_time = stime + 15;
		}
		else 
			start_time = stime;		// bcŝƂ͂tsL^n܂悤ɂB

		hRecvChkTh = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)recvchkthread_proc, NULL, 0, NULL);
		hCmdThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)cmdThread_proc, NULL, 0, NULL);

		tcb1 = usb->start_thread(0x86, BUF_LEN, QUE_NUM, write_func);

		if(bcas && !bView){
			tcb2 = usb->start_thread(0x84, 512, 1, write_bcas);
		}

		cmd[cmd_len++]=CMD_EP6IN_START;
		if(bcas && !bView)
			cmd[cmd_len++]=CMD_EP4IN_START;
		cmd[cmd_len++]=CMD_PORT_WRITE;
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//START=1
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START=1
#endif
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		log_out("JIUSB FX2 -> PC L^\n");
		usb->delete_thread(tcb1);
		if(bcas && !bView){
			usb->delete_thread(tcb2);
		}
		time_t etime = time(NULL);
		struct tm* etm = localtime(&etime);
		log_out("\n%02d:%02d:%02d L^I܂B\n",etm->tm_hour,etm->tm_min,etm->tm_sec);
		timeEndPeriod(1);

		if(bcas && !bView)
			fclose(wfp2);

		CloseHandle(hRecvChkTh);
		bCmdThreadStop = true;
		WaitForSingleObject(hCmdThread,1000);
		CloseHandle(hCmdThread);

		//dOFFp cap_stsIvpoffsȂ
		if(ir_post_cmd_num != 0 && !bStopEventRecv){
			ir_cmdtx(ir_post_cmd, ir_post_cmd_num);
			Sleep(500);
		}
		if(bSel) {
			int ChChange = pTsServiceSelect->GetChChangeCount();
			if(ChChange > 0)
				log_out("CHύXs܂B(:%d)\n",ChChange);
		}
		log_out("őgpMobt@ %dM(%d)^őgpB25obt@ %dK(%d)\n",(32 * m_LBuffer.m_nMaxCount) / 1024,m_LBuffer.m_nMaxCount,(188 * pTsDescrambler->m_nMaxCount) / 1024 ,pTsDescrambler->m_nMaxCount);
		log_out("t@C %s ̎M\n",tsfname);
		for(i=0;i<pTsSelectDump->GetDumpCount();i++) {
			time_t stime = pTsSelectDump->GetDumpSTime(i);
			time_t etime = pTsSelectDump->GetDumpETime(i);
			struct tm* etm = localtime(&etime);
			int ehour,emin,esec;
			ehour = etm->tm_hour;
			emin = etm->tm_min;
			esec= etm->tm_sec;
			etm = localtime(&stime);
			log_out("%02d:%02d:%02d`%02d:%02d:%02d, drop=%3I64d, scrambling=%I64d, biterror=%I64d\n", etm->tm_hour,etm->tm_min,etm->tm_sec,ehour,emin,esec,pTsSelectDump->GetDumpDrop(i),pTsSelectDump->GetDumpScrambling(i),pTsSelectDump->GetDumpBiterror(i));
		}
		for(i=0;i<8192;i++){
			if(pTsSelectDump->GetTotal(i) > 0){
				log_out("pid=0x%04x, total=%8I64d, drop=%3I64d, scrambling=%I64d, biterror=%I64d\n", i, pTsSelectDump->GetTotal(i), pTsSelectDump->GetDrop(i), pTsSelectDump->GetScrambling(i), pTsSelectDump->GetBiterror(i));
			}
		}
	}
	else{
		log_out("^[Qbg̃JIUSB FX2Fł܂B\n");
	}

	CloseHandle(hStopEvent);
	//delete m_pStreamBuf;
	//pTSPacketParser->Reset();
	//pTsServiceSelect->Reset();
	//pTsDescrambler->Reset();
	//pUdpOutput->Reset();
	//pFileWriter->Reset();
	delete pTSPacketParser;
	delete pTsServiceSelect;
	delete pTsDescrambler;
	delete pTsSelectDump;
	delete pUdpOutput;
	delete pFileWriter;

	delete usb;
	return 0;
}

